<!DOCTYPE html>
<html>
  <head>
    <title>Namecoin lightning</title>
    <meta charset="utf-8">
    <style>
      @import url(https://fonts.googleapis.com/css?family=Yanone+Kaffeesatz);
      @import url(https://fonts.googleapis.com/css?family=Droid+Serif:400,700,400italic);
      @import url(https://fonts.googleapis.com/css?family=Ubuntu+Mono:400,700,400italic);

      body { font-family: 'Yanone Kaffeesatz'; }
      h1, h2, h3, h4 {
        font-family: 'Yanone Kaffeesatz';
        font-weight: normal;
      }
      .remark-code, .remark-inline-code { font-family: 'Ubuntu Mono'; }

      .inverse {
        background: #272822;
        color: #777872;
        text-shadow: 0 0 20px #333;
      }
      .inverse h1, .inverse h2 .inverse h3 {
        color: #f3f3f3;
        line-height: 0.8em;
      }
    </style>
  </head>
  <body>
    <textarea id="source">

name: default
layout: true
class: center, middle

---

class: center, middle, inverse

# Namecoin
## (lightning)

???

- Prezentacja będzie z punktu widzenia zastosowań technicznych a nie samej słuszności technologi i/lub blockhainów.

---

![:scale 30%](img/namecoin.png)

### gitlab.com/szymon.szypulski/namecoin-lightning

???

- Slajdy mają załączone notatki w trybie prezentacji.

---

# Czym jest Namecoin?

???

- Pierwszy fork Bitcoina z 2011 roku.
- Rozproszony system DNS.
- 21 mln bloków, 'trudność' bloku podwaja się co 210000.
- Domena .bit (autor stara się o rezerwacje w ICANN).
- Ostatnio (2017) trochę odżył (https://coinmarketcap.com/currencies/namecoin/).
- Namecoin został zaprezentowany przed ICANN i nie został zmieszany z błotem (no prawie).

---

# Dlaczego Namecoin

???

- Może rozwiązać kilka problemów bieżącego świata (o tym później).
- Może być używany z IPFS/zeronet jako internet bez serwerów - i w sumie od tego trafiłem do Namecoina.

---

# Zoko triangle

![:scale 50%](img/zoko.png)

???

- Zestaw trzech własciwości porządanych w protokole sieciowym.
- Użytkownicy mają dostęp do łatwych do zapamiętania i łatwych do przyporządkowania nazw / przestrzeni nazw.
- Protokół jest bezpieczny, aby żaden pojedyńczy 'gracz', ani większość 'graczy' nie mógł/nie mogła samodzielnie działać na czyjąś szkode.
- Zdecentralizowany, czyli brak pojedyńczego punktu awarii.
- I to jest to co próbują osiągnąć twórcy Namecoina.

---

# Jak to działa?

???

- Proof of Work - minerzy akceptują transakcje.
- Opłata 0.02 NMC za rekord - 1NMC ~ $1.69, 0.02 NMC ~ $0.128 (13 centów).
- Rejestracja na trzy kroki
  - Najpierw rezerwacja domeny (registration fee 0.01 NMC + transaction fee 0.005 NMC), jeszcze nie mamy domeny.
  - Czekamy 12 bloków, 2-6 godzin. Ma to niby ustrzec przed squatingiem(?).
  - Pierwszy wpis rekordu w domenie (transaction fee - 0.005 NMC), od tego momentu domena jest ważna 36000 bloków.
  - Odnowienie domeny lub transfer (transaction fee - 0.005 NMC), ważność na kolejne 36000 bloków (~6 miesięcy).
  - Coiny użyte do transfery są oznaczane jako zużyte i niszczone jako zapłata dla górników (nie do końca wiem jak to się dzieje).
- Można tego dokonać samemu lub przez 3rd party
  - W wypadku 3rd party nie mamy pełnej kontroli nad domeną, nie nasze klucze nią zrządzają.
  - W wypadku samodzielnej rejestracji trzeba mieć kopie noda.
- Normalnie możemy zrobić delegacje domeny do serwerów DNS opartych na IP (tylko po co? :-))
- U klientów jest potrzebna warstwa translacji (pluginy do przeglądarek, standalone apki)
- Są już też mostki NamecoinToBind

---

# Zastosowania

???

Następny slajd

---

# Zdecentralizowany, bezpieczny, rozproszony DNS

???

- Nikt nie będzie w tym maczał palców.
- Nikła szansa na atak.
- Z założenia redukuje problem MITM.
  - Brak pośredników.

---

# Odpowiednik DNS DANE

???

- Namecoin może przechowywać informacje o certyfikatach przypisanych do domeny.
  - CA za pomocą którego certyfikaty dla danej domeny mogą być podpisane
  - Może zawierać skrót certyfikatu po prostu.
- Co ma wyeliminować zupełnie zbędne bagienko zaufania CA jakie mamy teraz
  - W 2011 DigiNotar (Holenderski CA) wystawił certy dla domen firm takich jak: CIA, MI6, Facebook, Microsoft,
Skype, Twitter, WordPress, Mozilla
  - W 2016 WoSign wystawiło certyfikat dla GitHub.com, po tym jak user okazał link do własnego commita hostowanego na GH.

---

# Zastępstwo dla onion

???

- Zamiast paskudnego 16 znakowego hasza.
- Jest zachowana anonimowość o ile transakcje nie będą z nikim powiązane (pierwszego bitcoina trzeba ukraść?:))

---

# Bardzo łatwe transfery

???

- Domene można przekazać w ramach transakcji coinowej.
- Kompletny brak pośredników.
- Prawie instant (czas wykopania/potwierdzenia).

---

# Zady

???

- TLD i tak są kontrolowane przez ICANN
  - Istnieje szansa przyblokowana .bit (np w przeglądarkach)
  - Albo chociaż utrudniania.
- Transakcje wymagają opłat - w tej chwili do prowadzenia własnego DNS potrzebujesz tylko maszyne, gdziekolwiek.
- Wygasanie co x dni / x transakcji.
  - Możliwe wrogie przejęcia.
  - Co jest też możliwe przy obecnym systemie DNS.
- Zgubiony klucz = zgubiona domena
  - W DNS'ach pilnuje za Ciebie tego twój registrar.
- Nie integruje się ootb z bieżącym światem.
  - Wymagane są apki / proxy.
- Nie ma weryfikacji trademarków.
  - Nikt nie kontroluje czy masz prawa do nazwy.
  - Prawdziwy dziki zachód.
- Limit transakcji per sekunda.
- Transakcje są publiczne.
  - Wszyscy wiedzą kto jest właścicielem czego.
  - O ile powiązą klucze z osobą.
- 'Baza' jest typu append only.
  - Będzie rosło.
  - Trzeba przechowywać całego noda.
- Wymaga dodatkowych narzędzi / warstwy translacji do komunikacji z 'obecnym' światem.
- Możliwy wzrost kosztów utrzymania domen wraz z popularnością (?).
- Zmiana rekordu to od 10 do 60 minut (w DNS można mieć TTL kilka sekund).

---

# Walety

???

- Transakcje są publiczne.
  - Widać kto jest włascicielem czego.
- Baza jest append only.
  - Żadnych zmian wstecz.
  - Jest cała historia.
- Jak już ma się zestawioną warstwe translacji to dla end-usera może nie być różnicy.
- Możliwość przetrzymywania danych na temat CA/certyfikatów.
- Multi-sig
  - Może być wymagane n z m kluczy do wprowadzenia zmian w domenie.
  - Świetny use-case dla organizacji.
  - Może to też działać jako 2FA.
  - Dając komuś uprawnienia na zasadzie multi-sig, możemy częściowo oddelegować odpowiedzialność za przedłużanie domeny.

---

# Bezpieczeństwo

???

- Z racji niskiej popularności, w przeszłości były 3 możliwości gdzie zewnętrzny gracz miał większość nodów/transakcji(?).
  - Były 2 forki(?).
- Teraz ponoć w namecoinie jest zaszyty kill switch, nie do końca rozumiem idee, mało o tym informacji.

---

# Podsumowanie

???

- Autor nie uważa tego za zbawienie DNS, ale jako coś co może funkcjonować obok DNS.
- Organizacje takie jak IANNA widzą problem w DNS i akceptują Namecoina jako jedno z możliwych rozwiązań, aczkolwiek nie
bez pewnej dozy sceptycyzmu.
- Osobiście uważam to za ciekawy projekt w połączeniu z innymi techikami (zeronet i ipfs). Niestety mus opłaty stawia to
pod lekką dyskusje, ataki z przeszłości też trochę martwią. Ograniczenie ilości transakcji może być wąskim gardłem całości.
- Może to być dobra podstawa ku innym podobnym inicjatywom w przyszłości.

---

# Pytania?


    </textarea>
    <script src="https://gnab.github.io/remark/downloads/remark-latest.min.js">
    </script>
    <script>
      remark.macros.scale = function (percentage) {
        var url = this;
        return '<img src="' + url + '" style="width: ' + percentage + '" />';
      };

      var slideshow = remark.create({
        highlightLines: true,
        highlightStyle: 'solarized-light'
      });
    </script>
  </body>
</html>
